SystemOrganization addCategory: #'Atividade4-MAC5714'!

TestCase subclass: #TabelaTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Atividade4-MAC5714'!

!TabelaTest methodsFor: 'as yet unclassified' stamp: 'it 6/19/2013 13:55'!
testGerarTabela
	| t o time |
	t := Tabela new.
	o := TabelaTextoObserver new.
	t addDependent: o.
	
	t jogoDo: 'Corinthians' contra: 'Palmeiras' foi: 0 a: 2.
	t jogoDo: 'Corinthians' contra: 'Sao Paulo' foi: 3 a: 1.
	t jogoDo: 'Palmeiras' contra: 'Sao Paulo' foi: 3 a: 1.
	
	time := t times first.
	self assert: ( time pontos = 6 )
	! !

Object subclass: #ResultadoTime
	instanceVariableNames: 'nome jogos vitorias empates derrotas golsPro golsContra'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Atividade4-MAC5714'!

!ResultadoTime methodsFor: 'accessing' stamp: 'it 6/15/2013 18:11'!
derrotas
	^ derrotas! !

!ResultadoTime methodsFor: 'accessing' stamp: 'it 6/15/2013 18:11'!
derrotas: anObject
	derrotas := anObject! !

!ResultadoTime methodsFor: 'accessing' stamp: 'it 6/15/2013 18:11'!
empates
	^ empates! !

!ResultadoTime methodsFor: 'accessing' stamp: 'it 6/15/2013 18:11'!
empates: anObject
	empates := anObject! !

!ResultadoTime methodsFor: 'accessing' stamp: 'it 6/15/2013 18:11'!
golsContra
	^ golsContra! !

!ResultadoTime methodsFor: 'accessing' stamp: 'it 6/15/2013 18:11'!
golsContra: anObject
	golsContra := anObject! !

!ResultadoTime methodsFor: 'accessing' stamp: 'it 6/15/2013 18:11'!
golsPro
	^ golsPro! !

!ResultadoTime methodsFor: 'accessing' stamp: 'it 6/15/2013 18:11'!
golsPro: anObject
	golsPro := anObject! !

!ResultadoTime methodsFor: 'accessing' stamp: 'it 6/15/2013 18:12'!
initialize
	super initialize.	jogos := vitorias := empates := derrotas := golsPro := golsContra := 0! !

!ResultadoTime methodsFor: 'accessing' stamp: 'it 6/15/2013 18:11'!
jogos
	^ jogos! !

!ResultadoTime methodsFor: 'accessing' stamp: 'it 6/15/2013 18:11'!
jogos: anObject
	jogos := anObject! !

!ResultadoTime methodsFor: 'accessing' stamp: 'it 6/15/2013 18:11'!
nome
	^ nome! !

!ResultadoTime methodsFor: 'accessing' stamp: 'it 6/15/2013 18:11'!
nome: anObject
	nome := anObject! !

!ResultadoTime methodsFor: 'accessing' stamp: 'it 6/15/2013 18:16'!
pontos
	^ (vitorias * 3) + empates! !

!ResultadoTime methodsFor: 'accessing' stamp: 'it 6/15/2013 18:16'!
print

	Transcript show: self nome; tab.
	Transcript show: self pontos; tab.
	Transcript show: self jogos; tab.
	Transcript show: self vitorias; tab.
	Transcript show: self empates; tab.
	Transcript show: self derrotas; tab.
	Transcript show: self golsPro; tab.
	Transcript show: self golsContra; tab.
	Transcript show: self saldoGols; cr! !

!ResultadoTime methodsFor: 'accessing' stamp: 'it 6/15/2013 18:16'!
saldoGols
	^ (golsPro - golsContra)! !

!ResultadoTime methodsFor: 'accessing' stamp: 'it 6/15/2013 18:11'!
vitorias
	^ vitorias! !

!ResultadoTime methodsFor: 'accessing' stamp: 'it 6/15/2013 18:11'!
vitorias: anObject
	vitorias := anObject! !

Object subclass: #Tabela
	instanceVariableNames: 'times'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Atividade4-MAC5714'!

Tabela class
	instanceVariableNames: 'uniqueInstance'!

Tabela class
	instanceVariableNames: 'uniqueInstance'!

!Tabela class methodsFor: 'as yet unclassified' stamp: 'it 6/15/2013 18:18'!
singleton
	uniqueInstance ifNil: [
		uniqueInstance := self basicNew initialize
	].
	^ uniqueInstance! !

!Tabela methodsFor: 'as yet unclassified' stamp: 'it 6/15/2013 18:17'!
atualizaTime: umTime golsPro: golsPro golsContra: golsContra
	| objTime |
	objTime := (times select: [ :time | time nome = umTime ]).
	(objTime isEmpty)
		ifTrue: [
			objTime := ResultadoTime new.
			objTime nome: umTime.
			times add: objTime ]
		ifFalse: [ objTime := objTime first ].
	
	objTime jogos: ((objTime jogos) + 1).
	objTime golsPro: ((objTime golsPro) + golsPro).
	objTime golsContra: ((objTime golsContra) + golsContra).
	
	^ objTime! !

!Tabela methodsFor: 'as yet unclassified' stamp: 'it 6/15/2013 18:17'!
do: aBlock
	times do: aBlock! !

!Tabela methodsFor: 'as yet unclassified' stamp: 'it 6/15/2013 18:17'!
initialize
	super initialize.
	times := SortedCollection sortBlock: [ :time1 :time2 | time1 pontos > time2 pontos ]! !

!Tabela methodsFor: 'as yet unclassified' stamp: 'it 6/15/2013 18:17'!
jogoDo: time1 contra: time2 foi: gols1 a: gols2
	| objTime1 objTime2 |
	objTime1 := self atualizaTime: time1 golsPro: gols1 golsContra: gols2.
	objTime2 := self atualizaTime: time2 golsPro: gols2 golsContra: gols1.
	
	( gols1 > gols2 )
		ifTrue: [
			objTime1 vitorias: ((objTime1 vitorias) + 1).
			objTime2 derrotas: ((objTime2 derrotas) + 1) ].
	( gols1 = gols2 )
		ifTrue: [
			objTime1 empates: ((objTime1 empates) + 1).
			objTime2 empates: ((objTime2 empates) + 1) ].
	( gols1 < gols2 )
		ifTrue: [
			objTime1 derrotas: ((objTime1 derrotas) + 1).
			objTime2 vitorias: ((objTime2 vitorias) + 1) ].

	self changed! !

!Tabela methodsFor: 'as yet unclassified' stamp: 'it 6/19/2013 13:53'!
times
	^ times! !

Object subclass: #TabelaTextoObserver
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Atividade4-MAC5714'!

!TabelaTextoObserver methodsFor: 'as yet unclassified' stamp: 'it 6/19/2013 13:50'!
update: umaTabela
	Transcript show: 'nome'; tab.
	Transcript show: 'pontos'; tab.
	Transcript show: 'jogos'; tab.
	Transcript show: 'vitorias'; tab.
	Transcript show: 'empates'; tab.
	Transcript show: 'derrotas'; tab.
	Transcript show: 'golsPro'; tab.
	Transcript show: 'golsContra'; tab.
	Transcript show: 'saldoGols'; cr.
	
	umaTabela do: [ :time | time print ]! !
